<?php
/**
 * A specialized class loader for this class
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright(c) 2007, 2008 Roland Haeder, this is free software
 * @license		GNU GPL 3.0 or any newer version
 * @link 		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

// Is the application instance set?
if (!isset($application)) {
	// We need this!
	ApplicationEntryPoint::app_die("[Main:] Interne Variable <strong>application</strong> nicht gefunden!");
}

// Load all classes for the application
foreach ($lowerClasses as $class) {
	// Try to load the application classes
	try {
		ClassLoader::getInstance()->loadClasses(sprintf("%s/%s/%s", FrameworkConfiguration::getInstance()->readConfig("application_path"), $application, $class));
	} catch (PathIsNoDirectoryException $e) {
		ApplicationEntryPoint::app_die(sprintf("[Main:%s] Kann Applikationsklassen im Pfad <strong>%s</strong> nicht laden. Grund: <strong>%s</strong>",
			$application,
			$class,
			$e->getMessage()
		));
	} catch (PathIsEmptyException $e) {
		ApplicationEntryPoint::app_die(sprintf("[Main:%s] Kann Applikationsklassen im Pfad <strong>%s</strong> nicht laden. Grund: <strong>%s</strong>",
			$application,
			$class,
			$e->getMessage()
		));
	} catch (PathReadProtectedException $e) {
		ApplicationEntryPoint::app_die(sprintf("[Main:%s] Kann Applikationsklassen im Pfad <strong>%s</strong> nicht laden. Grund: <strong>%s</strong>",
			$application,
			$class,
			$e->getMessage()
		));
	} catch (DirPointerNotOpenedException $e) {
		ApplicationEntryPoint::app_die(sprintf("[Main:%s] Kann Applikationsklassen im Pfad <strong>%s</strong> nicht laden. Grund: <strong>%s</strong>",
			$application,
			$class,
			$e->getMessage()
		));
	}
}

// Include all classes
ClassLoader::getInstance()->includeAllClasses();

// Clean up the global namespace
unset($lowerClasses);
unset($class);

// [EOF]
?>
